Adornments in Vue TextBox

20 Aug 202623 minutes to read

Adornments allow you to add custom elements before or after the TextBox using prependTemplate and appendTemplate. These elements can include icons, text labels, or action buttons to improve usability and provide visual context.

Overview

Adornments are useful for:

  • Visual Context: Adding icons that indicate the expected input type (e.g., user icon for username, envelope icon for email)
  • Functional Enhancement: Including action buttons such as password visibility toggles or clear buttons
  • Input Validation: Displaying validation status icons or error indicators
  • Unit Indicators: Showing currency symbols, temperature units, domain extensions, or measurement units
  • Accessibility: Providing visual and interactive guidance to help users input and improve discoverability

Common Use Cases

  • Visual Indicators: Icons for expected input type (e.g., user icon for username, envelope icon for email).
  • Functional Enhancements: Buttons for password visibility toggle or clear input.
  • Validation Status: Icons for error or success indicators.
  • Unit Indicators: Currency symbols, measurement units, or domain extensions.

Adding Adornments to TextBox

Use prependTemplate and appendTemplate properties to add custom HTML content before and after the TextBox.

  • prependTemplate: Renders elements before the TextBox.
  • appendTemplate: Renders elements after the TextBox.

The following example demonstrates how to add adornments in the TextBox control.

<template>
    <div>
        <div class="col-lg-12 control-section adornment-textbox">
            <div class="content-wrapper">
                <div class="row">
                    <ejs-textbox floatLabelType="Auto" cssClass="e-prepend-textbox" placeholder="Enter your Name" :prependTemplate="'prependTemplate'">
                        <template v-slot:prependTemplate>
                            <span class="e-icons e-user"></span>
                            <span class="e-input-separator"></span>
                        </template>
                    </ejs-textbox>
                </div>
                <div class="row">
                    <ejs-textbox id="append" floatLabelType="Auto" cssClass="e-eye-icon" placeholder="Password" :appendTemplate="'appendTemplate'">
                        <template v-slot:appendTemplate>
                            <span class="e-input-separator"></span>
                            <span id="text-icon" class="e-icons e-eye"></span>
                        </template>
                    </ejs-textbox>
                </div>
                <div class="row">
                    <ejs-textbox id="iconTemplate" floatLabelType="Auto" cssClass="e-icon-textbox" placeholder="Enter the Mail Address" :prependTemplate="'prependIconTemplate'" :appendTemplate="'appendIconTemplate'">
                        <template v-slot:prependIconTemplate>
                            <span class="e-icons e-people"></span>
                            <span class="e-input-separator"></span>
                        </template>
                        <template v-slot:appendIconTemplate>
                            <span>.com</span>
                            <span class="e-input-separator"></span>
                            <span id="delete-text" class="e-icons e-trash"></span>
                        </template>
                    </ejs-textbox>
                </div>
            </div>
        </div> 
    </div>
</template>

<style>
    .adornment-textbox .content-wrapper {
        width: 35% !important;
        margin: 5% auto !important;
        min-width: 185px;
    }
    .adornment-textbox .row,
    .adornment-textbox .row {
        margin: 7% 0;
    }
    .e-float-input span:not([class]):not(.e-float-text):not(.e-input-separator):not(.e-delete-text) {
        line-height: 1; 
        padding-right: 5px;
    }
    .material3 .e-eye-icon label.e-float-text,
    .material3-dark .e-eye-icon label.e-float-text {
        top: -3px !important;
    }
    .bootstrap5_3 .adornment-textbox .e-icon-textbox .e-float-text,
    .bootstrap5_3 .adornment-textbox  .e-prepend-textbox .e-float-text,
    .bootstrap5_3-dark .adornment-textbox .e-icon-textbox .e-float-text,
    .bootstrap5_3-dark .adornment-textbox  .e-prepend-textbox .e-float-text,
    .tailwind3 .adornment-textbox .e-icon-textbox .e-float-text,
    .tailwind3 .adornment-textbox  .e-prepend-textbox .e-float-text,
    .tailwind3-dark .adornment-textbox .e-icon-textbox .e-float-text,
    .tailwind3-dark .adornment-textbox  .e-prepend-textbox .e-float-text  {
        padding-left: 0 !important;
    }
    .material3 .adornment-textbox label.e-float-text.e-label-bottom,
    .material3-dark .adornment-textbox label.e-float-text.e-label-bottom {
        top: -2px !important;
    }
    .bootstrap5_3 .adornment-textbox label.e-float-text.e-label-bottom,
    .bootstrap5_3-dark .adornment-textbox label.e-float-text.e-label-bottom {
        top: 17px !important;
    }
    .tailwind3 .adornment-textbox label.e-float-text.e-label-bottom,
    .tailwind3-dark .adornment-textbox label.e-float-text.e-label-bottom {
        top: 18px !important;
    }
    .fluent2-highcontrast .adornment-textbox label.e-float-text.e-label-bottom {
        top: -9px !important;
    }
    .fluent2 .adornment-textbox label.e-float-text.e-label-bottom,
    .fluent2-dark .adornment-textbox label.e-float-text.e-label-bottom {
        top: -9px !important;
    }
    .bootstrap5_3 .adornment-textbox .e-prepend-template,
    .bootstrap5_3-dark .adornment-textbox .e-prepend-template {
        padding-right: 0 !important;
    }
    .adornment-textbox .e-eye-icon .e-icons.e-eye,
    .adornment-textbox .e-eye-icon .e-icons.e-eye-slash,
    .adornment-textbox .e-icon-textbox .e-icons.e-trash {
        cursor: pointer;
    }
</style>

<script setup>
import { TextBoxComponent } from '@syncfusion/ej2-vue-inputs';
import { getComponent } from '@syncfusion/ej2-base';
import { onMounted } from 'vue';

onMounted(() => {
    const textIcon = document.querySelector('#text-icon');
    if (textIcon) {
        textIcon.addEventListener('click', function() {
            const appendTextbox = getComponent(document.getElementById('append'), 'textbox');
            if (appendTextbox.type === 'text') {
                appendTextbox.type = 'Password';
                textIcon.className = 'e-icons e-eye-slash';
            } else {
                appendTextbox.type = 'text';
                textIcon.className = 'e-icons e-eye';
            }
            appendTextbox.dataBind();
        });
    }
    const deleteIcon = document.querySelector('#delete-text');
    if (deleteIcon) {
        deleteIcon.addEventListener('click', function() {
            const iconTextbox = getComponent(document.getElementById('iconTemplate'), 'textbox');
            iconTextbox.value = '';
            iconTextbox.dataBind();
        });
    }
});
</script>
<template>
    <div>
        <div class="col-lg-12 control-section adornment-textbox">
            <div class="content-wrapper">
                <div class="row">
                    <ejs-textbox floatLabelType="Auto" cssClass="e-prepend-textbox" placeholder="Enter your Name" :prependTemplate="'prependTemplate'">
                        <template v-slot:prependTemplate>
                            <span class="e-icons e-user"></span>
                            <span class="e-input-separator"></span>
                        </template>
                    </ejs-textbox>
                </div>
                <div class="row">
                    <ejs-textbox id="append" floatLabelType="Auto" cssClass="e-eye-icon" placeholder="Password" :appendTemplate="'appendTemplate'">
                        <template v-slot:appendTemplate>
                            <span class="e-input-separator"></span>
                            <span id="text-icon" class="e-icons e-eye"></span>
                        </template>
                    </ejs-textbox>
                </div>
                <div class="row">
                    <ejs-textbox id="iconTemplate" floatLabelType="Auto" cssClass="e-icon-textbox" placeholder="Enter the Mail Address" :prependTemplate="'prependIconTemplate'" :appendTemplate="'appendIconTemplate'">
                        <template v-slot:prependIconTemplate>
                            <span class="e-icons e-people"></span>
                            <span class="e-input-separator"></span>
                        </template>
                        <template v-slot:appendIconTemplate>
                            <span>.com</span>
                            <span class="e-input-separator"></span>
                            <span id="delete-text" class="e-icons e-trash"></span>
                        </template>
                    </ejs-textbox>
                </div>
            </div>
        </div> 
    </div>
</template>


<script>
import { TextBoxComponent } from '@syncfusion/ej2-vue-inputs';
import { getComponent } from '@syncfusion/ej2-base';

export default {
    data: function() {
        return {};
    },
    components: { 
        'ejs-textbox': TextBoxComponent
    },
    mounted: function() {
        var textIcon = document.querySelector('#text-icon');
        if (textIcon) {
            textIcon.addEventListener('click', function() {
                var appendTextbox = getComponent(document.getElementById('append'), 'textbox');
                if (appendTextbox.type === 'text') {
                    appendTextbox.type = 'Password';
                    textIcon.className = 'e-icons e-eye-slash';
                } else {
                    appendTextbox.type = 'text';
                    textIcon.className = 'e-icons e-eye';
                }
                appendTextbox.dataBind();
            });
        }
        var deleteIcon = document.querySelector('#delete-text');
        if (deleteIcon) {
            deleteIcon.addEventListener('click', function() {
                var iconTextbox = getComponent(document.getElementById('iconTemplate'), 'textbox');
                iconTextbox.value = '';
                iconTextbox.dataBind();
            });
        }
    }
};

</script>
<style>

    .adornment-textbox .content-wrapper {
        width: 35% !important;
        margin: 5% auto !important;
        min-width: 185px;
    }
    .adornment-textbox .row,
    .adornment-textbox .row {
        margin: 7% 0;
    }
    .e-float-input span:not([class]):not(.e-float-text):not(.e-input-separator):not(.e-delete-text) {
        line-height: 1; 
        padding-right: 5px;
    }
    .material3 .e-eye-icon label.e-float-text,
    .material3-dark .e-eye-icon label.e-float-text {
        top: -3px !important;
    }
    .bootstrap5_3 .adornment-textbox .e-icon-textbox .e-float-text,
    .bootstrap5_3 .adornment-textbox  .e-prepend-textbox .e-float-text,
    .bootstrap5_3-dark .adornment-textbox .e-icon-textbox .e-float-text,
    .bootstrap5_3-dark .adornment-textbox  .e-prepend-textbox .e-float-text,
    .tailwind3 .adornment-textbox .e-icon-textbox .e-float-text,
    .tailwind3 .adornment-textbox  .e-prepend-textbox .e-float-text,
    .tailwind3-dark .adornment-textbox .e-icon-textbox .e-float-text,
    .tailwind3-dark .adornment-textbox  .e-prepend-textbox .e-float-text  {
        padding-left: 0 !important;
    }
    .material3 .adornment-textbox label.e-float-text.e-label-bottom,
    .material3-dark .adornment-textbox label.e-float-text.e-label-bottom {
        top: -2px !important;
    }
    .bootstrap5_3 .adornment-textbox label.e-float-text.e-label-bottom,
    .bootstrap5_3-dark .adornment-textbox label.e-float-text.e-label-bottom {
        top: 17px !important;
    }
    .tailwind3 .adornment-textbox label.e-float-text.e-label-bottom,
    .tailwind3-dark .adornment-textbox label.e-float-text.e-label-bottom {
        top: 18px !important;
    }
    .fluent2-highcontrast .adornment-textbox label.e-float-text.e-label-bottom {
        top: -9px !important;
    }
    .fluent2 .adornment-textbox label.e-float-text.e-label-bottom,
    .fluent2-dark .adornment-textbox label.e-float-text.e-label-bottom {
        top: -9px !important;
    }
    .bootstrap5_3 .adornment-textbox .e-prepend-template,
    .bootstrap5_3-dark .adornment-textbox .e-prepend-template {
        padding-right: 0 !important;
    }
    .adornment-textbox .e-eye-icon .e-icons.e-eye,
    .adornment-textbox .e-eye-icon .e-icons.e-eye-slash,
    .adornment-textbox .e-icon-textbox .e-icons.e-trash {
        cursor: pointer;
    }
</style>

You can view the demo here: TextBox Adornments demo.

Adornments in Angular TextBox

25 Sep 20266 minutes to read

The Angular TextBox component supports adornments that allow you to add custom elements before or after the textbox using prependTemplate and appendTemplate. Adornment elements can include icons, text labels, or action buttons to improve usability and provide visual context.

Overview

Adornments are useful for:

  • Visual Context: Adding icons that indicate the expected input type (e.g., user icon for username, envelope icon for email)
  • Functional Enhancement: Including action buttons such as password visibility toggles or clear buttons
  • Input Validation: Displaying validation status icons or error indicators
  • Unit Indicators: Showing currency symbols, temperature units, domain extensions, or measurement units
  • Accessibility: Providing visual and interactive guidance to help users enter data and improve discoverability.

Common Use Cases

  • Visual Indicators: Icons for expected input type (e.g., user icon for username, envelope icon for email).
  • Functional Enhancements: Buttons for password visibility toggle or clear input.
  • Validation Status: Icons for error or success indicators.
  • Unit Indicators: Currency symbols, measurement units, or domain extensions.

Adding Adornments to Angular TextBox

Use the prependTemplate and appendTemplate properties to add custom HTML content before and after the textbox.

  • prependTemplate: Renders elements before the textbox input.
  • appendTemplate: Renders elements after the textbox input.

The following example demonstrates how to add adornments in the Angular TextBox control.

import { Component, ViewEncapsulation } from '@angular/core';
import { TextBoxModule } from '@syncfusion/ej2-angular-inputs';

@Component({
  selector: 'app-root',
  styleUrls: ['.././index.css'],
  template: `
    <div class="col-lg-12 control-section adornments">
      <div class="content-wrapper">
        <div class="row">
          <ejs-textbox
            placeholder="Enter your Name"
            cssClass="e-prepend-textbox"
            floatLabelType="Auto"
            [prependTemplate]="prependTemplate">
            <ng-template #prependTemplate>
              <span class="e-icons e-user"></span>
              <span class="e-input-separator"></span>
            </ng-template>
          </ejs-textbox>
        </div>

        <div class="row">
          <ejs-textbox
            placeholder="Password"
            cssClass="e-eye-icon"
            floatLabelType="Auto"
            [(value)]="password"
            [type]="passwordType"
            [appendTemplate]="appendTemplate">
            <ng-template #appendTemplate>
              <span class="e-input-separator"></span>
              <span
                class="e-icons"
                [class.e-eye]="passwordType === 'password'"
                [class.e-eye-slash]="passwordType === 'text'"
                (click)="onEyeIconClick($event)">
              </span>
            </ng-template>
          </ejs-textbox>
        </div>

        <div class="row">
          <ejs-textbox
            placeholder="Enter the Mail Address"
            cssClass="e-icon-textbox"
            floatLabelType="Auto"
            [(value)]="email"
            [prependTemplate]="prependIconTemplate"
            [appendTemplate]="appendIconTemplate">
            <ng-template #prependIconTemplate>
              <span class="e-icons e-people"></span>
              <span class="e-input-separator"></span>
            </ng-template>
            <ng-template #appendIconTemplate>
              <span>.com</span>
              <span class="e-input-separator"></span>
              <span class="e-icons e-trash" (click)="onDeleteClick()"></span>
            </ng-template>
          </ejs-textbox>
        </div>
      </div>
    </div>
  `,
  standalone: true,
  encapsulation: ViewEncapsulation.None,
  imports: [TextBoxModule]
})
export class AppComponent {

  public password: string = '';
  public passwordType: 'password' | 'text' = 'password';
  public email: string = '';

  onEyeIconClick(e: MouseEvent): void {
    this.passwordType = this.passwordType === 'password' ? 'text' : 'password';
  }

  onDeleteClick(): void {
    this.email = '';
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

You can view the demo here: Angular TextBox Adornments demo.

Adornments in React TextBox

Enhance the React TextBox component with prepended or appended visual elements using prependTemplate and appendTemplate properties. Adornments include icons, text labels, or interactive buttons that provide visual context and improve the user input experience.

Overview and Use Cases

Adornments serve multiple purposes in modern form design:

  • Visual Indicators: Icons that clarify the expected input type (e.g., user icon for username, envelope icon for email)
  • Functional Enhancement: Action buttons such as password visibility toggles or clear input buttons
  • Validation Feedback: Icons indicating input validity or error states
  • Unit Display: Currency symbols, measurement units, or domain extensions (e.g., “@domain.com” for email fields)
  • Accessibility Support: Visual and interactive cues that enhance discoverability and usability for all users

Adding Adornments to React TextBox

Use the prependTemplate and appendTemplate properties to insert custom HTML elements before or after the TextBox input field:

  • prependTemplate: Renders content before (to the left of) the TextBox input
  • appendTemplate: Renders content after (to the right of) the TextBox input

The following example demonstrates how to add adornments in the TextBox control.

[Class-component]

import * as React from 'react';
import * as ReactDOM from "react-dom";
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';

export default class App extends React.Component {
  constructor(props) {
    super(props);
    this.appendTextboxObj = React.createRef();
    this.iconTextboxObj = React.createRef();
  }

  prependTemplate = () => {
    return (
      <>
        <span className="e-icons e-user"></span>
        <span className="e-input-separator"></span>
      </>
    );
  };

  appendTemplate = () => {
    const handleClick = (e) => {
      let textIcon = e.target;
      if (textIcon) {
        if (this.appendTextboxObj.current.type === 'text') {
          this.appendTextboxObj.current.type = 'Password';
          textIcon.className = 'e-icons e-eye-slash';
        } else {
          this.appendTextboxObj.current.type = 'text';
          textIcon.className = 'e-icons e-eye';
        }
      }
    };
    return (
      <>
        <span className="e-input-separator"></span>
        <span
          id="text-icon"
          className="e-icons e-eye"
          onClick={handleClick}
        ></span>
      </>
    );
  };

  prependIconTemplate = () => {
    return (
      <>
        <span className="e-icons e-people"></span>
        <span className="e-input-separator"></span>
      </>
    );
  };

  appendIconTemplate = () => {
    const handleDeleteClick = () => {
      this.iconTextboxObj.current.value = '';
    };
    return (
      <>
        <span>.com</span>
        <span className="e-input-separator"></span>
        <span
          className="e-icons e-trash"
          onClick={handleDeleteClick}
        ></span>
      </>
    );
  };

  render() {
    return (
      <div className='control-pane'>
        <div className='col-lg-12 control-section adornment-textbox'>
          <div className="content-wrapper sample-icon">
            <div className="row">
              <TextBoxComponent
                placeholder="Enter your Name"
                cssClass="e-prepend-textbox"
                floatLabelType="Auto"
                prependTemplate={this.prependTemplate}
              />
            </div>
            <div className="row">
              <TextBoxComponent
                ref={this.appendTextboxObj}
                placeholder="Password"
                floatLabelType="Auto"
                cssClass="e-eye-icon"
                appendTemplate={this.appendTemplate}
              />
            </div>
            <div className="row custom-margin-row">
              <TextBoxComponent
                ref={this.iconTextboxObj}
                placeholder="Enter the Mail Address"
                cssClass="e-icon-textbox"
                floatLabelType="Auto"
                prependTemplate={this.prependIconTemplate}
                appendTemplate={this.appendIconTemplate}
              />
            </div>
          </div>
        </div>
      </div>
    );
  }
}

ReactDOM.render(<App />,document.getElementById('sample'));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';

interface AdornmentsState {}

export default class App extends React.Component<{}, AdornmentsState> {
  private appendTextboxObj = React.createRef<TextBoxComponent>();
  private iconTextboxObj = React.createRef<TextBoxComponent>();

  constructor(props: {}) {
    super(props);
  }

  prependTemplate = (): React.ReactNode => {
    return (
      <>
        <span className="e-icons e-user"></span>
        <span className="e-input-separator"></span>
      </>
    );
  };

  appendTemplate = (): React.ReactNode => {
    const handleClick = (e: React.MouseEvent<HTMLSpanElement>): void => {
      const textIcon = e.target as HTMLSpanElement;
      if (textIcon && this.appendTextboxObj.current) {
        if (this.appendTextboxObj.current.type === 'text') {
          this.appendTextboxObj.current.type = 'Password';
          textIcon.className = 'e-icons e-eye-slash';
        } else {
          this.appendTextboxObj.current.type = 'text';
          textIcon.className = 'e-icons e-eye';
        }
      }
    };
    return (
      <>
        <span className="e-input-separator"></span>
        <span
          id="text-icon"
          className="e-icons e-eye"
          onClick={handleClick}
        ></span>
      </>
    );
  };

  prependIconTemplate = (): React.ReactNode => {
    return (
      <>
        <span className="e-icons e-people"></span>
        <span className="e-input-separator"></span>
      </>
    );
  };

  appendIconTemplate = (): React.ReactNode => {
    const handleDeleteClick = (): void => {
      if (this.iconTextboxObj.current) {
        this.iconTextboxObj.current.value = '';
      }
    };
    return (
      <>
        <span>.com</span>
        <span className="e-input-separator"></span>
        <span
          className="e-icons e-trash"
          onClick={handleDeleteClick}
        ></span>
      </>
    );
  };

  render(): React.ReactNode {
    return (
      <div className='control-pane'>
        <div className='col-lg-12 control-section adornment-textbox'>
          <div className="content-wrapper sample-icon">
            <div className="row">
              <TextBoxComponent
                placeholder="Enter your Name"
                cssClass="e-prepend-textbox"
                floatLabelType="Auto"
                prependTemplate={this.prependTemplate}
              />
            </div>
            <div className="row">
              <TextBoxComponent
                ref={this.appendTextboxObj}
                placeholder="Password"
                floatLabelType="Auto"
                cssClass="e-eye-icon"
                appendTemplate={this.appendTemplate}
              />
            </div>
            <div className="row custom-margin-row">
              <TextBoxComponent
                ref={this.iconTextboxObj}
                placeholder="Enter the Mail Address"
                cssClass="e-icon-textbox"
                floatLabelType="Auto"
                prependTemplate={this.prependIconTemplate}
                appendTemplate={this.appendIconTemplate}
              />
            </div>
          </div>
        </div>
      </div>
    );
  }
}
ReactDOM.render(<App />,document.getElementById('sample'));

You can view the demo here: TextBox Adornments demo.

[Functional-component]

import * as React from "react";
import * as ReactDOM from "react-dom";
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';

function App() {
  const appendTextboxRef = React.useRef(null);
  const iconTextboxRef = React.useRef(null);

  const prependTemplate = () => (
    <>
      <span className="e-icons e-user"></span>
      <span className="e-input-separator"></span>
    </>
  );

  const appendTemplate = () => {
    const handleClick = (e) => {
      const textIcon = e.target;
      const inst = appendTextboxRef.current;
      if (!inst) return;

      if (inst.type === 'text') {
        inst.type = 'password';
        inst.dataBind();
        textIcon.className = 'e-icons e-eye-slash';
      } else {
        inst.type = 'text';
        inst.dataBind();
        textIcon.className = 'e-icons e-eye';
      }
    };

    return (
      <>
        <span className="e-input-separator"></span>
        <span id="text-icon" className="e-icons e-eye" onClick={handleClick}></span>
      </>
    );
  };

  const prependIconTemplate = () => (
    <>
      <span className="e-icons e-people"></span>
      <span className="e-input-separator"></span>
    </>
  );

  const appendIconTemplate = () => {
    const handleDeleteClick = () => {
      const inst = iconTextboxRef.current;
      if (!inst) return;
      inst.value = '';
      inst.dataBind();
    };
    return (
      <>
        <span>.com</span>
        <span className="e-input-separator"></span>
        <span className="e-icons e-trash" onClick={handleDeleteClick}></span>
      </>
    );
  };

  return (
    <div className='control-pane'>
      <div className='col-lg-12 control-section adornment-textbox'>
        <div className="content-wrapper sample-icon">
          <div className="row">
            <TextBoxComponent
              placeholder="Enter your Name"
              cssClass="e-prepend-textbox"
              floatLabelType="Auto"
              prependTemplate={prependTemplate}
            />
          </div>

          <div className="row">
            <TextBoxComponent
              ref={appendTextboxRef}
              placeholder="Password"
              type="password"
              floatLabelType="Auto"
              cssClass="e-eye-icon"
              appendTemplate={appendTemplate}
            />
          </div>

          <div className="row custom-margin-row">
            <TextBoxComponent
              ref={iconTextboxRef}
              placeholder="Enter the Mail Address"
              cssClass="e-icon-textbox"
              floatLabelType="Auto"
              prependTemplate={prependIconTemplate}
              appendTemplate={appendIconTemplate}
            />
          </div>
        </div>
      </div>
    </div>
  );
}

ReactDOM.render(<App />, document.getElementById('sample'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';

function App() {
  const appendTextboxObj = React.useRef<TextBoxComponent>(null);
  const iconTextboxObj = React.useRef<TextBoxComponent>(null);

  const prependTemplate = () => (
    <>
      <span className="e-icons e-user"></span>
      <span className="e-input-separator"></span>
    </>
  );

  const appendTemplate = () => {
    const handleClick = (e: React.MouseEvent<HTMLSpanElement>) => {
      const textIcon = e.currentTarget;
      if (appendTextboxObj.current) {
        if (appendTextboxObj.current.type === 'text') {
          appendTextboxObj.current.type = 'Password';
          textIcon.className = 'e-icons e-eye-slash';
        } else {
          appendTextboxObj.current.type = 'text';
          textIcon.className = 'e-icons e-eye';
        }
      }
    };
    return (
      <>
        <span className="e-input-separator"></span>
        <span id="text-icon" className="e-icons e-eye" onClick={handleClick}></span>
      </>
    );
  };

  const prependIconTemplate = () => (
    <>
      <span className="e-icons e-people"></span>
      <span className="e-input-separator"></span>
    </>
  );

  const appendIconTemplate = () => {
    const handleDeleteClick = () => {
      if (iconTextboxObj.current) {
        iconTextboxObj.current.value = '';
      }
    };
    return (
      <>
        <span>.com</span>
        <span className="e-input-separator"></span>
        <span className="e-icons e-trash" onClick={handleDeleteClick}></span>
      </>
    );
  };
  return (
    <div className="control-pane">
      <div className="col-lg-12 control-section adornment-textbox">
        <div className="content-wrapper sample-icon">
          <div className="row">
            <TextBoxComponent
              placeholder="Enter your Name"
              cssClass="e-prepend-textbox"
              floatLabelType="Auto"
              prependTemplate={prependTemplate}
            />
          </div>
          <div className="row">
            <TextBoxComponent
              ref={appendTextboxObj}
              placeholder="Password"
              floatLabelType="Auto"
              cssClass="e-eye-icon"
              appendTemplate={appendTemplate}
            />
          </div>
          <div className="row custom-margin-row">
            <TextBoxComponent
              ref={iconTextboxObj}
              placeholder="Enter the Mail Address"
              cssClass="e-icon-textbox"
              floatLabelType="Auto"
              prependTemplate={prependIconTemplate}
              appendTemplate={appendIconTemplate}
            />
          </div>
        </div>
      </div>
    </div>
  );
}

ReactDOM.render(<App />, document.getElementById('sample'));

You can view the demo here: TextBox Adornments demo.